#include <windows.h>
#include <stdio.h>
#include <commctrl.h>

#include "resource.h"
#include "http.h"

#ifdef RELEASE
    #define CLIENT_URL "http://LOCALHOST.org/files/LOCALHOST.exe"
#else
    #define CLIENT_URL "http://LOCALHOST.org/files/LOCALHOST-dev.exe"
#endif

struct download_data
{
    HWND progress;
    FILE *fh;
    bool abort;
};

static struct download_data data;

bool download_write(void *buf, size_t size, size_t file_pos, size_t file_size, struct download_data *data)
{
    if (data->abort)
        return false;

    if (data->progress)
    {
        PostMessage(data->progress, PBM_SETPOS, (WPARAM)(((float)file_pos / file_size) * 100), 0);
    }

    return fwrite(buf, size, 1, data->fh) == 1;
}

static DWORD download_thread(HWND hwnd)
{
    char path[MAX_PATH], dir[MAX_PATH], *file;
    GetModuleFileName(NULL, path, MAX_PATH);
    GetFullPathName(path, sizeof dir, dir, &file);

    http_init();

    if (!file)
    {
        MessageBox(NULL, "Error finding my own filename, the heck?", "LOCALHOST", MB_OK|MB_ICONERROR);
        PostMessage(hwnd, WM_USER+2, 0, 0);
        return 0;
    }

    data.fh = fopen("LOCALHOST.tmp", "wb");

    if (!data.fh)
    {
        MessageBox(NULL, "Error opening LOCALHOST.tmp for writing. Could you please remove it for me?", "LOCALHOST", MB_OK|MB_ICONERROR);
        PostMessage(hwnd, WM_USER+2, 0, 0);
        return 0;
    }

    data.progress = GetDlgItem(hwnd, IDC_PROGRESS);
    SendMessage(data.progress, PBM_SETRANGE, 0, MAKELPARAM(0, 100));

    if (http_get(CLIENT_URL, (HTTP_CALLBACK)download_write, &data))
    {
        STARTUPINFO sInfo;
        PROCESS_INFORMATION pInfo;

        fclose(data.fh);

        rename(file, "LOCALHOST.ex_");
        rename("LOCALHOST.tmp", file);

        ZeroMemory(&sInfo, sizeof sInfo);
        sInfo.cb = sizeof sInfo;
        ZeroMemory(&pInfo, sizeof pInfo);
        if (CreateProcess(NULL, file, NULL, NULL, TRUE, 0, NULL, NULL, &sInfo, &pInfo) == 0)
        {
            MessageBox(NULL, "Error restarting, new exe is corrupted? :-(", "LOCALHOST", MB_OK|MB_ICONERROR);
        }
    }
    else
    {
        fclose(data.fh);
    }

    http_release();

    PostMessage(hwnd, WM_USER+2, 0, 0);

    return 0;
}

INT_PTR CALLBACK download_DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        case WM_INITDIALOG:

            SendMessage(hwnd, WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)LoadIcon(GetModuleHandle(NULL), "small"));
            SendMessage(hwnd, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)LoadIcon(GetModuleHandle(NULL), "large"));

            CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)download_thread, hwnd, 0, NULL);

            return TRUE;

        case WM_USER+2:

            EndDialog(hwnd, wParam);

            return TRUE;

        case WM_CLOSE:
            data.abort = true;
    }

    return FALSE;
}

